/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.h
  * @brief          : Header for main.c file.
  *                   This file contains the common defines of the application.
  ******************************************************************************
  * @attention
  *
  * <h2><center>&copy; Copyright (c) 2019 STMicroelectronics.
  * All rights reserved.</center></h2>
  *
  * This software component is licensed by ST under BSD 3-Clause license,
  * the "License"; You may not use this file except in compliance with the
  * License. You may obtain a copy of the License at:
  *                        opensource.org/licenses/BSD-3-Clause
  *
  ******************************************************************************
  */
/* USER CODE END Header */

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __MAIN_H
#define __MAIN_H

#ifdef __cplusplus
extern "C" {
#endif

/* Includes ------------------------------------------------------------------*/
#include "stm32l4xx_hal.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <stdio.h>
#include "uart.h"
#include "TMP75AIDGKR.h"
#include "bma253.h"
/* USER CODE END Includes */

/* Exported types ------------------------------------------------------------*/
/* USER CODE BEGIN ET */

/* USER CODE END ET */

/* Exported constants --------------------------------------------------------*/
/* USER CODE BEGIN EC */

/* USER CODE END EC */

/* Exported macro ------------------------------------------------------------*/
/* USER CODE BEGIN EM */

/* USER CODE END EM */

/* Exported functions prototypes ---------------------------------------------*/
void Error_Handler(void);

/* USER CODE BEGIN EFP */
extern I2C_HandleTypeDef hi2c1;
extern I2C_HandleTypeDef hi2c2;
extern I2C_HandleTypeDef hi2c3;

/* USER CODE END EFP */

/* Private defines -----------------------------------------------------------*/
#define A_SENSOR_INT1_Pin GPIO_PIN_13
#define A_SENSOR_INT1_GPIO_Port GPIOC
#define BOOT_LED_Pin GPIO_PIN_15
#define BOOT_LED_GPIO_Port GPIOC
#define RUN_MODE_Pin GPIO_PIN_0
#define RUN_MODE_GPIO_Port GPIOA
#define TPB22_3_TX_Pin GPIO_PIN_2
#define TPB22_3_TX_GPIO_Port GPIOA
#define TPB22_3_RX_Pin GPIO_PIN_3
#define TPB22_3_RX_GPIO_Port GPIOA
#define EEPROM_SCL_Pin GPIO_PIN_7
#define EEPROM_SCL_GPIO_Port GPIOA
#define Run_Mode_LED_Pin GPIO_PIN_0
#define Run_Mode_LED_GPIO_Port GPIOB
#define Run_Mode_Pin GPIO_PIN_1
#define Run_Mode_GPIO_Port GPIOB
#define UBX_M8030KT__TX_Pin GPIO_PIN_10
#define UBX_M8030KT__TX_GPIO_Port GPIOB
#define UBX_M8030KT_RX_Pin GPIO_PIN_11
#define UBX_M8030KT_RX_GPIO_Port GPIOB
#define BMA253_SCL_Pin GPIO_PIN_13
#define BMA253_SCL_GPIO_Port GPIOB
#define BMA253_SDA_Pin GPIO_PIN_14
#define BMA253_SDA_GPIO_Port GPIOB
#define GUI_TX_Pin GPIO_PIN_9
#define GUI_TX_GPIO_Port GPIOA
#define GUI_RX_Pin GPIO_PIN_10
#define GUI_RX_GPIO_Port GPIOA
#define TPB22_3_EN_Pin GPIO_PIN_3
#define TPB22_3_EN_GPIO_Port GPIOB
#define EEPROM_SDA_Pin GPIO_PIN_4
#define EEPROM_SDA_GPIO_Port GPIOB
#define UBX_M8030_EN_Pin GPIO_PIN_5
#define UBX_M8030_EN_GPIO_Port GPIOB
#define TMP75AIDGKR_SCL_Pin GPIO_PIN_6
#define TMP75AIDGKR_SCL_GPIO_Port GPIOB
#define TMP75AIDGKR_SDA_Pin GPIO_PIN_7
#define TMP75AIDGKR_SDA_GPIO_Port GPIOB
#define TMP75AIDGKR_ALERT_Pin GPIO_PIN_8
#define TMP75AIDGKR_ALERT_GPIO_Port GPIOB
#define SENSEO_EN_Pin GPIO_PIN_9
#define SENSEO_EN_GPIO_Port GPIOB
/* USER CODE BEGIN Private defines */

/* USER CODE END Private defines */

#ifdef __cplusplus
}
#endif

#endif /* __MAIN_H */

/************************ (C) COPYRIGHT STMicroelectronics *****END OF FILE****/
